/** ******************************************************************************
 * @file    GM190_DTU
 * @author  
 * @brief   GM190 DTU汾 1.0
 ******************************************************************************
 * @attention
 * <h2><center>&copy; Copyright (c) 2019 ɶδ
 * All rights reserved.</center></h2>
 * ע:cubemx ɵhalٿ
 * :keil5.0
 * STM32Cube FW_F1 V1.8.0
 * ļ汾1.0		ʱ2020/12/17   汾
 ********************************************************************************/

#include <stdio.h>
#include <string.h>

#include "main.h"
#include "iwdg.h"
#include "usart.h"
#include "wwdg.h"
#include "gpio.h"

#include <stdarg.h>		
#include <stdlib.h>		
#include <stdbool.h>
#include "serialport.h"					/*ںļܹ*/
#include "gm190_library.h"			/*gm190*/
#include "malloc.h"							/*̬ڴ滮*/	
#include "data_manage.h"				/*ڴͷ*/	
#include "dtu.h"								/*DTU*/	
#include "dtu_mode.h"						/*DTUģʽ*/	
#include "debug_task.h"					/*ʵ*/

#include "at_module.h"

SerialCore serial1;

SerialCore serial2;

void SystemClock_Config(void);

DoubleCache(data1,data2,512);
DoubleCache(data3,data4,512);

extern char * g_TCPHEARTTIME;

void DEBUG_OVER(uint8_t *cache,int length)
{
	info("յ:%s",cache);
	module_printf((char*)cache);	
}

void MODULE_OVER(uint8_t *cache,int length)
{
	serial2.Send(cache,length);
}

extern uint8_t live(void);
extern char * g_TCPHEART;
extern uint8_t  ledMode;
int main(void)
{

  HAL_Init();
  SystemClock_Config();
  MX_GPIO_Init();
  MX_USART1_UART_Init();
  MX_USART2_UART_Init();

  //MX_WWDG_Init();
  MX_IWDG_Init();

	/*ʱ汾ǶĿ⣬ûвgm190*/
	
	/*ʼдڲflash*/
	Flash_init();	
	
	/*פ*/
	ledMode=2;
	
	/*󶨺ĺ*/
	UartCoreBind(&serial1,&huart1);
	
	/*עһϾص*/
	serial1.RegistPuncCallBack(MODULE_OVER);
	/*װ˫*/
	serial1.LoadCache(data1,data2,sizeof(data2));

	/*󶨺ĺ*/
	UartCoreBind(&serial2,&huart2);
	/*עһϾص*/
	serial2.RegistPuncCallBack(DEBUG_OVER);
	/*װ˫*/
	serial2.LoadCache(data3,data4,sizeof(data4));	
	
	/*úʹ˵Է*/
	SetDebugSerial(&huart2);
	/*úʹģ鷢*/
	SetModuleSerial(&huart1);
	
	/**/
	SetCoreIsModule(&serial1);
	
	/*עģʽҪĻص*/
	serial2.RegistHookCallBack((uint8_t*)"CONFIG",CONFIG_Instruction,1);	
	
	info("");

	/*ע*/
	serial1.RegistHookCallBack((uint8_t*)"\x0d\x0a+ZIPSTAT: 1,0",TCP_OUTLINE,1);
	
	QUEERY_ALL(1);
	
	/*ÿ30sѯһ*/
	//TimedTaskRegister(30000,LOOP_QUERRY_MQTT);
	
	/*ʼ*/
	if(g_TCPHEART!=0)
	{
		int time=atoi(g_TCPHEARTTIME);
		if(time==0) time=60;
		info("ȡʱɹ:%d s",time);
		TimedTaskRegister(time*1000,live);
		
		TimeTaskStart(live,0);
	}



	
	while(1) 
	{

		UartCoreLoop();
		/*ȼ*/
		MODULE_POWER_LOOP();
		/*ȼڶ*/
		MODULE_NET_LOOP();
		/*TCPȼ*/
		TCP_LOOP();
		
		NET_LED_LOOP();
	}
}

void HAL_UART_RxCpltCallback(UART_HandleTypeDef *huart)
{
	UartCoreRxIT(huart);
}

/**
  * @brief System Clock Configuration
  * @retval None
  */
void SystemClock_Config(void)
{
  RCC_OscInitTypeDef RCC_OscInitStruct = {0};
  RCC_ClkInitTypeDef RCC_ClkInitStruct = {0};

  /** Initializes the CPU, AHB and APB busses clocks 
  */
  RCC_OscInitStruct.OscillatorType = RCC_OSCILLATORTYPE_HSI|RCC_OSCILLATORTYPE_LSI;
  RCC_OscInitStruct.HSIState = RCC_HSI_ON;
  RCC_OscInitStruct.HSICalibrationValue = RCC_HSICALIBRATION_DEFAULT;
  RCC_OscInitStruct.LSIState = RCC_LSI_ON;
  RCC_OscInitStruct.PLL.PLLState = RCC_PLL_ON;
  RCC_OscInitStruct.PLL.PLLSource = RCC_PLLSOURCE_HSI_DIV2;
  RCC_OscInitStruct.PLL.PLLMUL = RCC_PLL_MUL16;
  if (HAL_RCC_OscConfig(&RCC_OscInitStruct) != HAL_OK)
  {
    Error_Handler();
  }
  /** Initializes the CPU, AHB and APB busses clocks 
  */
  RCC_ClkInitStruct.ClockType = RCC_CLOCKTYPE_HCLK|RCC_CLOCKTYPE_SYSCLK
                              |RCC_CLOCKTYPE_PCLK1|RCC_CLOCKTYPE_PCLK2;
  RCC_ClkInitStruct.SYSCLKSource = RCC_SYSCLKSOURCE_PLLCLK;
  RCC_ClkInitStruct.AHBCLKDivider = RCC_SYSCLK_DIV1;
  RCC_ClkInitStruct.APB1CLKDivider = RCC_HCLK_DIV2;
  RCC_ClkInitStruct.APB2CLKDivider = RCC_HCLK_DIV1;

  if (HAL_RCC_ClockConfig(&RCC_ClkInitStruct, FLASH_LATENCY_2) != HAL_OK)
  {
    Error_Handler();
  }
}

/* USER CODE BEGIN 4 */

/* USER CODE END 4 */

/**
  * @brief  This function is executed in case of error occurrence.
  * @retval None
  */
void Error_Handler(void)
{
  /* USER CODE BEGIN Error_Handler_Debug */
  /* User can add his own implementation to report the HAL error return state */

  /* USER CODE END Error_Handler_Debug */
}

#ifdef  USE_FULL_ASSERT
/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(uint8_t *file, uint32_t line)
{ 
  /* USER CODE BEGIN 6 */
  /* User can add his own implementation to report the file name and line number,
     tex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
  /* USER CODE END 6 */
}
#endif /* USE_FULL_ASSERT */

/************************ (C) COPYRIGHT STMicroelectronics *****END OF FILE****/
