/* ******************************************************************************
 * @file    ME3616.c
 * @author  δ DOIOT
 * @brief   EC20ģATָ״
 ******************************************************************************
 * @attention
 * <h2><center>&copy; Copyright (c) 2019 ɶδ
 * All rights reserved.</center></h2>
 * ע:cubemx ɵhalٿ
 * :keil5.0
 * STM32Cube FW_F1 V1.8.0
 ********************************************************************************/

#include "stmflash.h"
#include "usart.h"
#include "string.h"
#include "serialport.h"

uint16_t STMFLASH_ReadHalfWord(uint32_t faddr)
{
	return *(vu16*)faddr; 
}

/*дʹ*/
#if STM32_FLASH_WREN	  

/**	
* @brief	д	
*	@param WriteAddr:ʼַ(˵ַΪ2ı!!
*	@param pBuffer:ָ
*	@param NumToWrite:(16λ)(Ҫд16λݵĸ.)
*/
void STMFLASH_Write_NoCheck(uint32_t WriteAddr,uint16_t *pBuffer,uint16_t NumToWrite)   
{ 			 		 
	uint16_t i;
	for(i=0;i<NumToWrite;i++)
	{
		HAL_FLASH_Program(FLASH_TYPEPROGRAM_HALFWORD,WriteAddr,pBuffer[i]);
	    WriteAddr+=2;//ַ2.
	}  
} 

/**	
* @briefַָʼָȵ		
*	@param WriteAddr:ʼַ(˵ַΪ2ı!!
*	@param pBuffer:ָ
*	@param NumToWrite:(16λ)(Ҫд16λݵĸ.)
*/

#if STM32_FLASH_SIZE<256
#define STM_SECTOR_SIZE 1024 //ֽ
#else 
#define STM_SECTOR_SIZE	2048   /*С2k*/
#endif		 
uint16_t STMFLASH_BUF[STM_SECTOR_SIZE/2];//2Kֽ
void STMFLASH_Write(uint32_t WriteAddr,uint16_t *pBuffer,uint16_t NumToWrite)	
{
	uint32_t secpos;	   //ַ
	uint16_t secoff;	   //ƫƵַ(16λּ)
	uint16_t secremain; //ʣַ(16λּ)	   
 	uint16_t i;    
	uint32_t offaddr;   //ȥ0X08000000ĵַ
	
	if(WriteAddr<STM32_FLASH_BASE||(WriteAddr>=(STM32_FLASH_BASE+1024*STM32_FLASH_SIZE)))return;//Ƿַ
	
	HAL_FLASH_Unlock();					//
	offaddr=WriteAddr-STM32_FLASH_BASE;		//ʵƫƵַ.
	secpos=offaddr/STM_SECTOR_SIZE;			//ַ  0~127 for STM32F103RBT6
	secoff=(offaddr%STM_SECTOR_SIZE)/2;		//ڵƫ(2ֽΪλ.)
	secremain=STM_SECTOR_SIZE/2-secoff;		//ʣռС   
	if(NumToWrite<=secremain)secremain=NumToWrite;//ڸΧ
	while(1) 
	{	
		STMFLASH_Read(secpos*STM_SECTOR_SIZE+STM32_FLASH_BASE,STMFLASH_BUF,STM_SECTOR_SIZE/2);//
		for(i=0;i<secremain;i++)	//У
		{
			if(STMFLASH_BUF[secoff+i]!=0XFFFF)break;//Ҫ  	  
		}
		if(i<secremain)				//Ҫ
		{
			FLASH_PageErase(secpos*STM_SECTOR_SIZE+STM32_FLASH_BASE);	//
			FLASH_WaitForLastOperation(FLASH_WAITETIME);            	//ȴϴβ
			CLEAR_BIT(FLASH->CR, FLASH_CR_PER);							//CRĴPERλ˲ӦFLASH_PageErase()ɣ
																		//HAL沢ûӦHALbug
			for(i=0;i<secremain;i++)//
			{
				STMFLASH_BUF[i+secoff]=pBuffer[i];	  
			}
			STMFLASH_Write_NoCheck(secpos*STM_SECTOR_SIZE+STM32_FLASH_BASE,STMFLASH_BUF,STM_SECTOR_SIZE/2);//д  
		}else 
		{
			FLASH_WaitForLastOperation(FLASH_WAITETIME);       	//ȴϴβ
			STMFLASH_Write_NoCheck(WriteAddr,pBuffer,secremain);//дѾ˵,ֱдʣ. 
		}
		if(NumToWrite==secremain)break;//д
		else//дδ
		{
			secpos++;				//ַ1
			secoff=0;				//ƫλΪ0 	 
		   	pBuffer+=secremain;  	//ָƫ
			WriteAddr+=secremain*2;	//дַƫ(16λݵַ,Ҫ*2)	   
		   	NumToWrite-=secremain;	//ֽ(16λ)ݼ
			if(NumToWrite>(STM_SECTOR_SIZE/2))secremain=STM_SECTOR_SIZE/2;//һд
			else secremain=NumToWrite;//һд
		}	 
	};	
	HAL_FLASH_Lock();		//
}
#endif

/**	
* @briefַָʼָȵ		
*	@param ReadAddr:ʼַ	
*	@param pBuffer:ָ	
*	@param NumToWrite:(16λ)
*/
void STMFLASH_Read(uint32_t ReadAddr,uint16_t *pBuffer,uint16_t NumToRead)   	
{
	uint16_t i;
	for(i=0;i<NumToRead;i++)
	{
		pBuffer[i]=STMFLASH_ReadHalfWord(ReadAddr);//ȡ2ֽ.
		ReadAddr+=2;//ƫ2ֽ.	
	}
}


/**
* @brief  ڲflashַдַ
* @param  WriteAddr 	: ַҪżַ
*	@param  string			:	ַ
	洢ݵǰλ洢ַȡ
*/
#define string_Operation_length   128
void Flash_Write_Str(uint32_t WriteAddr,char *string)
{
	
	uint16_t str_buff[string_Operation_length];
	uint16_t buff=0;
	int i=0,len=strlen(string);
	if(len>string_Operation_length)
	{
		debug_printf("\r\nȳΧ޸Ŀɲȵĺ\r\n");
		return;
	}
	str_buff[1]=len;/*һλ洢*/
	/*תҪĳ*/
	
	for(i=0;i<len/2&&i<string_Operation_length;i++)
	{
		buff=(uint8_t)*(string+i*2);
		buff=buff<<8;
		buff|=(uint8_t)*(string+i*2+1);
		str_buff[i+2]=buff;
		buff=0;
	}
	if(len%2==1)
	{
		buff=(uint8_t)*(string+i*2);
		buff=buff<<8;
		str_buff[i+2]=buff;
	}
	STMFLASH_Write(WriteAddr,str_buff,len);
}
/**
* @brief  ڲflashַȡַֻܶȡFlash_Write_Stringдַ
* @param  WriteAddr 	: ַҪżַ
*	@param  string			:	char
*/
void Flash_Read_Str(uint32_t ReadAddr,char string[])
{
	uint16_t str_buff[string_Operation_length]={0};
	STMFLASH_Read( ReadAddr,str_buff,string_Operation_length);
	uint8_t buff=0;
	int i=0,len=str_buff[1];
	for(i=0;i<len/2&&i<string_Operation_length;i++)
	{
		buff=*(str_buff+i+2)>>8;
		*(string+i*2)=buff;
		buff=(uint8_t)*(str_buff+i+2);
		*(string+i*2+1)=buff;
	}
	if(len%2==1)
	{
		buff=*(str_buff+i+2)>>8;
		*(string+i*2)=buff;
	}
	else
	*(string+len)='\0';/*0ַ*/
}

/**
* @brief  ڲflashַдu32
* @param  WriteAddr 	: ַҪżַ
*	@param  arry			  :	u32ַ
*	@param  length			:	Ҫдĳ
*/
#define u32_Operation_length   128
void Flash_Write_u32(uint32_t WriteAddr,uint32_t arry[],uint32_t length)
{

	uint16_t buff=0;
	uint16_t save_arry[u32_Operation_length];
	uint8_t  i=0;
	for(i=0;i<length&&i<u32_Operation_length/2;i++)
	{
		buff=(uint16_t)(*(arry+i)>>16);
		save_arry[i*2]=buff;
		buff=(uint16_t)*(arry+i);
		save_arry[i*2+1]=buff;
	}
	STMFLASH_Write(WriteAddr,save_arry,length*2);
}
/**
* @brief  ڲflashַȡu32
* @param  WriteAddr 	: ַҪżַ
*	@param  arry			  :	u32ַ
*	@param  length			:	Ҫĳ
*/
void Flash_Read_u32(uint32_t ReadAddr,uint32_t arry[],uint32_t length)
{
	uint32_t buff=0;
	uint16_t read_arry[u32_Operation_length];	
	STMFLASH_Read( ReadAddr,read_arry,u32_Operation_length);
	uint8_t  i=0;
	
	for(i=0;i<length&&i<u32_Operation_length/2;i++)
	{
		/*+2ǰ洢˳ȵƫ*/
		buff=(*(read_arry+i*2));
		buff=buff<<16;
		buff|=*(read_arry+i*2+1);
		arry[i]=buff;
	}
}

/**
* @brief  ڲflashַдu16
* @param  WriteAddr 	: ַҪżַ
*	@param  arry			  :	u16ַ
*	@param  length			:	Ҫдĳ
*/
#define u16_Operation_length   128
void Flash_Write_u16(uint32_t WriteAddr,uint16_t arry[],uint32_t length)
{
	STMFLASH_Write(WriteAddr,arry,length+2);
}

/**
* @brief  ڲflashַȡu16
* @param  WriteAddr 	: ַҪżַ
*	@param  arry			  :	u16ַ
*	@param  length			:	Ҫдĳ
*/
#define u16_Operation_length   128
void Flash_Read_u16(uint32_t ReadAddr,uint16_t arry[],uint32_t length)
{
	STMFLASH_Read(ReadAddr,arry,length);
}


/**
* @brief  ڲflashַдu8
* @param  WriteAddr 	: ַҪżַ
*	@param  arry			  :	u8ַ
*	@param  length			:	Ҫдĳ
	洢ݵǰλ洢ȡ
*/
#define u8_Operation_length   128
void Flash_Write_u8(uint32_t WriteAddr,uint8_t arry[],uint32_t length)
{
	//uint16_t save_arry[u8_Operation_length];
	STMFLASH_Write(WriteAddr,(uint16_t*)arry,length/2);
}

void Flash_Read_u8(uint32_t ReadAddr,uint8_t arry[],uint32_t length)
{
	STMFLASH_Read(ReadAddr,(uint16_t*)arry,length/2);
}


void Flash_And_Read_Test()
{
	char str[10];
	debug_printf("\r\nַд\r\n");
	Flash_Write_Str(0X08030000,"abcdef123456ð");
	
	Flash_Read_Str(0X08030000,str);
	debug_printf("\r\n:abcdef123456ð");
	debug_printf("\r\nȡ:%s",str);
	
	debug_printf("\r\nu32д\r\n");	
	
	uint32_t	arry1[3]={0x12345678,0x87654321,0x54878956}; 
	Flash_Write_u32(0X08030000,arry1,3);
	memset(arry1,0,3);
	Flash_Read_u32(0X08030000,arry1,3);
	
	debug_printf("\r\n:0x12345678,0x87654321,0x54878956");
	debug_printf("\r\nȡ:0x%x,0x%x,0x%x",arry1[0],arry1[1],arry1[2]);

	debug_printf("\r\nu16д\r\n");	
	
	uint16_t	arry2[3]={0x1234,0x8765,0x5487}; 
	Flash_Write_u16(0X08030000,arry2,3);
	memset(arry1,0,3);
	Flash_Read_u16(0X08030000,arry2,3);
	
	debug_printf("\r\n:0x1234,0x8765,0x5487");
	debug_printf("\r\nȡ:0x%x,0x%x,0x%x",arry2[0],arry2[1],arry2[2]);
	
	debug_printf("\r\nu8д\r\n");	
	
	uint8_t	arry3[3]={0x12,0x65,0x87}; 
	Flash_Write_u8(0X08030000,arry3,3);
	memset(arry1,0,3);
	Flash_Read_u8(0X08030000,arry3,3);
	debug_printf("\r\n:0x12,0x65,0x87");
	debug_printf("\r\nȡ:0x%x,0x%x,0x%x",arry3[0],arry3[1],arry3[2]);
	
}
